/**
 * Create a buffer of the given size (uninitialized, so it may contain random data).
 *
 * Note that the result is either Uin8Array or Buffer, depending on the environment.
 * Buffer from NodeJS works slightly different than Uint8Array.
 */
export declare const createBuffer: (size: number) => Uint8Array;
/**
 * Concat multiple buffers into one.
 */
export declare function bufferConcat(chunks: Uint8Array[], length?: number): Uint8Array;
export declare const uint8ArrayToUtf8: (buffer: Uint8Array) => any;
/**
 * Convert a buffer to a string.
 */
export declare function bufferToString(buffer: string | Uint8Array): string;
export declare function nativeBase64ToUint8Array(base64: string): Uint8Array;
/**
 * Converts a base64 string to a Uint8Array.
 */
export declare const base64ToUint8Array: (v: string) => Uint8Array;
