"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isInteger = exports.isArray = exports.AsyncFunction = exports.__ΩExtractClassType = exports.__ΩAbstractClassType = exports.__ΩClassType = exports.__ΩCustomError = exports.CustomError = void 0;
exports.getClassName = getClassName;
exports.getClassPropertyName = getClassPropertyName;
exports.applyDefaults = applyDefaults;
exports.identifyType = identifyType;
exports.isPlainObject = isPlainObject;
exports.getClassTypeFromInstance = getClassTypeFromInstance;
exports.isClassInstance = isClassInstance;
exports.stringifyValueWithType = stringifyValueWithType;
exports.changeClass = changeClass;
exports.prettyPrintObject = prettyPrintObject;
exports.isFunction = isFunction;
exports.isAsyncFunction = isAsyncFunction;
exports.isPromise = isPromise;
exports.isClass = isClass;
exports.isGlobalClass = isGlobalClass;
exports.isObject = isObject;
exports.isObjectLiteral = isObjectLiteral;
exports.isNull = isNull;
exports.isUndefined = isUndefined;
exports.isSet = isSet;
exports.isNumber = isNumber;
exports.isNumeric = isNumeric;
exports.isString = isString;
exports.indexOf = indexOf;
exports.sleep = sleep;
exports.copy = copy;
exports.empty = empty;
exports.size = size;
exports.firstKey = firstKey;
exports.lastKey = lastKey;
exports.first = first;
exports.last = last;
exports.average = average;
exports.prependObjectKeys = prependObjectKeys;
exports.appendObject = appendObject;
exports.asyncOperation = asyncOperation;
exports.fixAsyncOperation = fixAsyncOperation;
exports.mergePromiseStack = mergePromiseStack;
exports.createStack = createStack;
exports.mergeStack = mergeStack;
exports.ensureError = ensureError;
exports.collectForMicrotask = collectForMicrotask;
exports.time = time;
exports.getPathValue = getPathValue;
exports.setPathValue = setPathValue;
exports.deletePathValue = deletePathValue;
exports.humanBytes = humanBytes;
exports.getObjectKeysSize = getObjectKeysSize;
exports.isConstructable = isConstructable;
exports.isPrototypeOfBase = isPrototypeOfBase;
exports.getParentClass = getParentClass;
exports.getInheritanceChain = getInheritanceChain;
exports.inDebugMode = inDebugMode;
exports.createDynamicClass = createDynamicClass;
exports.isIterable = isIterable;
exports.iterableSize = iterableSize;
exports.getCurrentFileName = getCurrentFileName;
exports.escapeRegExp = escapeRegExp;
exports.hasProperty = hasProperty;
exports.range = range;
exports.rangeArray = rangeArray;
exports.zip = zip;
exports.forwardTypeArguments = forwardTypeArguments;
exports.formatError = formatError;
exports.assertInstanceOf = assertInstanceOf;
exports.assertDefined = assertDefined;
const __ΩObject = [() => Function, 'constructor', 'toString', 'toLocaleString', 0, 'valueOf', () => __ΩPropertyKey, 'v', 'hasOwnProperty', 0, 'isPrototypeOf', () => __ΩPropertyKey, 'propertyIsEnumerable', 'Object', 'PPu!4"P&1#P&1$Pn%1&Pn\'2()1)Pn*2()1+Pn,2()1-Mw.y'];
const __ΩError = ['name', 'message', 'stack', 'Error', 'P&4!&4"&4#8Mw$y'];
const __ΩIterableIterator = ['T', 'TReturn', 'TNext', () => __ΩIterator, 0, () => Symbol.iterator, 'IterableIterator', 'b!"c""c#Pe"!e""e"#o$$Pe#!e#"e##o%$1&Mw\'y'];
const __ΩPropertyKey = ['PropertyKey', 'P&\'+Jw!y'];
const __ΩIterator = ['T', 'TReturn', 'TNext', 'param0', () => __ΩIteratorResult, 'next', 'value', () => __ΩIteratorResult, 'return', 'e', () => __ΩIteratorResult, 'throw', 'Iterator', 'b!"c""c#PPPPGPe%#GJ@2$e#!e#"o%#1&Pe#"2\'8e#!e#"o(#1)P"2*8e#!e#"o+#1,Mw-y'];
const __ΩIteratorResult = ['T', 'TReturn', () => __ΩIteratorYieldResult, () => __ΩIteratorReturnResult, 'IteratorResult', 'b!"c"Pe"!o#"e""o$"Jw%y'];
const __ΩIteratorYieldResult = ['TYield', false, 'done', 'value', 'IteratorYieldResult', 'b!P."4#8e"!4$Mw%y'];
const __ΩIteratorReturnResult = ['TReturn', true, 'done', 'value', 'IteratorReturnResult', 'b!P."4#e"!4$Mw%y'];
function __assignType(fn, args) {
    fn.__type = args;
    return fn;
}
/*
 * Deepkit Framework
 * Copyright (C) 2021 Deepkit UG, Marc J. Schmidt
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the MIT License.
 *
 * You should have received a copy of the MIT License along with this program.
 */
const dot_prop_1 = __importDefault(require("dot-prop"));
const iterators_js_1 = require("./iterators.js");
/**
 * Makes sure the error once printed using console.log contains the actual class name.
 *
 * @example
 * ```
 * class MyApiError extends CustomerError {}
 *
 * throw MyApiError() // prints MyApiError instead of simply "Error".
 * ```
 *
 * @public
 */
class CustomError extends Error {
    constructor(...args) {
        super(...args);
        this.name = this.constructor.name;
    }
}
exports.CustomError = CustomError;
CustomError.__type = [() => Error, 'name', 'args', 'constructor', 'CustomError', 'P7!&3"P"@2#"0$5w%'];
const __ΩCustomError = ['cause', 'CustomError', 'P#4!8Mw"y'];
exports.__ΩCustomError = __ΩCustomError;
const __ΩClassType = ['T', 'args', 'new', 'ClassType', '"c!PP"@2"e#!1#Mw$y'];
exports.__ΩClassType = __ΩClassType;
const __ΩAbstractClassType = ['T', 'args', 'new', 'AbstractClassType', '"c!P"@2"e"!/#w$y'];
exports.__ΩAbstractClassType = __ΩAbstractClassType;
const __ΩExtractClassType = ['T', () => __ΩAbstractClassType, 'ExtractClassType', 'l:e"!R!RPde#!h!!o""qk#\'QRb!Pde"!p)w#y'];
exports.__ΩExtractClassType = __ΩExtractClassType;
/**
 * Returns the class name either of the class definition or of the class of an instance.
 *
 * Note when code is minimized/uglified this output will change. You should disable in your compile the
 * className modification.
 *
 * @example
 * ```typescript
 * class User {}
 *
 * expect(getClassName(User)).toBe('User');
 * expect(getClassName(new User())).toBe('User');
 * ```
 *
 * @public
 */
function getClassName(classTypeOrInstance) {
    if (!classTypeOrInstance)
        return 'undefined';
    const proto = classTypeOrInstance['prototype'] ? classTypeOrInstance['prototype'] : classTypeOrInstance;
    return proto.constructor.name || 'anonymous class';
}
getClassName.__type = [() => __ΩClassType, () => __ΩObject, 'classTypeOrInstance', 'getClassName', 'PP"o!"n"J2#&/$'];
/**
 * Same as getClassName but appends the propertyName.
 * @public
 */
function getClassPropertyName(classType, propertyName) {
    const name = getClassName(classType);
    return `${name}.${propertyName}`;
}
getClassPropertyName.__type = [() => __ΩClassType, () => __ΩObject, 'classType', 'propertyName', 'getClassPropertyName', 'PP"o!"n"J2#&2$&/%'];
/**
 * @public
 */
function applyDefaults(classType, target) {
    const classInstance = new classType();
    for (const [i, v] of (0, iterators_js_1.eachPair)(target)) {
        classInstance[i] = v;
    }
    return classInstance;
}
applyDefaults.__type = [() => __ΩClassType, 'classType', 'target', 'applyDefaults', 'P"o!"2"P&"LM2#"/$'];
/**
 * Tries to identify the object by normalised result of Object.toString(obj).
 */
function identifyType(obj) {
    return ((({}).toString.call(obj).match(/\s([a-zA-Z]+)/) || [])[1] || '').toLowerCase();
}
identifyType.__type = ['obj', 'identifyType', 'P"2!"/"'];
/**
 * Returns true if the given obj is a plain object, and no class instance.
 *
 * isPlainObject(\{\}) === true
 * isPlainObject(new ClassXY) === false
 *
 * @public
 */
function isPlainObject(obj) {
    return Boolean(obj && typeof obj === 'object' && obj.constructor instanceof obj.constructor);
}
isPlainObject.__type = ['obj', 'isPlainObject', 'P"2!!/"'];
/**
 * Returns the ClassType for a given instance.
 */
function getClassTypeFromInstance(target) {
    if (!isClassInstance(target)) {
        throw new Error(`Value is not a class instance. Got ${stringifyValueWithType(target)}`);
    }
    return target['constructor'];
}
getClassTypeFromInstance.__type = ['target', () => __ΩClassType, 'getClassTypeFromInstance', 'P"2!"o""/#'];
/**
 * Returns true when target is a class instance.
 */
function isClassInstance(target) {
    return target !== undefined && target !== null
        && target['constructor']
        && Object.getPrototypeOf(target) === target['constructor'].prototype
        && !isPlainObject(target)
        && isObject(target);
}
isClassInstance.__type = ['target', 'isClassInstance', 'P"2!)/"'];
/**
 * Returns a human-readable string representation from the given value.
 */
function stringifyValueWithType(value, depth = 0) {
    if ('string' === typeof value)
        return `string(${value})`;
    if ('number' === typeof value)
        return `number(${value})`;
    if ('boolean' === typeof value)
        return `boolean(${value})`;
    if ('bigint' === typeof value)
        return `bigint(${value})`;
    if (isPlainObject(value))
        return `object ${depth < 2 ? prettyPrintObject(value, depth) : ''}`;
    if ((0, exports.isArray)(value))
        return `Array`;
    if (isClass(value))
        return `${getClassName(value)}`;
    if (isObject(value))
        return `${getClassName(getClassTypeFromInstance(value))} ${depth < 2 ? prettyPrintObject(value, depth) : ''}`;
    if ('function' === typeof value)
        return `function ${value.name}`;
    if (null === value)
        return `null`;
    return 'undefined';
}
stringifyValueWithType.__type = ['value', 'depth', () => 0, 'stringifyValueWithType', 'P"2!\'2">#&/$'];
/**
 * Changes the class of a given instance and returns the new object.
 *
 * @example
 * ```typescript
 *
 *  class Model1 {
 *    id: number = 0;
 *  }
 *
 *  class Model2 {
 *    id: number = 0;
 *  }
 *
 *  const model1 = new Model1();
 *  const model2 = changeClass(model1, Model2);
 *  model2 instanceof Model2; //true
 * ```
 */
function changeClass(value, newClass) {
    return Object.assign(Object.create(newClass.prototype), value);
}
changeClass.__type = ['value', () => __ΩClassType, 'newClass', 'changeClass', 'P%2!"o""2#"/$'];
function prettyPrintObject(object, depth = 0) {
    const res = [];
    for (const i in object) {
        res.push(i + ': ' + stringifyValueWithType(object[i], depth + 1));
    }
    return '{' + res.join(',') + '}';
}
prettyPrintObject.__type = ['object', 'depth', () => 0, 'prettyPrintObject', 'P%2!\'2">#&/$'];
/**
 * Returns true if given obj is a function.
 *
 * @public
 */
function isFunction(obj) {
    if ('function' === typeof obj) {
        return !obj.toString().startsWith('class ') && !obj.toString().startsWith('class{');
    }
    return false;
}
isFunction.__type = ['obj', 'isFunction', 'P"2!!/"'];
exports.AsyncFunction = (async () => {
}).constructor;
/**
 * Returns true if given obj is a async function.
 *
 * @public
 */
function isAsyncFunction(obj) {
    return obj instanceof exports.AsyncFunction;
}
isAsyncFunction.__type = ['obj', 'isAsyncFunction', 'P"2!!/"'];
/**
 * Returns true if given obj is a promise like object.
 *
 * Note: There's not way to check if it's actually a Promise using instanceof since
 * there are a lot of different implementations around.
 *
 * @public
 */
function isPromise(obj) {
    return obj !== null && typeof obj === 'object' && typeof obj.then === 'function'
        && typeof obj.catch === 'function' && typeof obj.finally === 'function';
}
isPromise.__type = ['obj', 'isPromise', 'PP""`J2!!/"'];
/**
 * Returns true if given obj is a ES6 class (ES5 fake classes are not supported).
 *
 * @public
 */
function isClass(obj) {
    if ('function' === typeof obj) {
        return obj.toString().startsWith('class ') || obj.toString().startsWith('class{');
    }
    return false;
}
isClass.__type = ['obj', 'isClass', 'P"2!!/"'];
function isGlobalClass(obj) {
    if ('function' !== typeof obj)
        return false;
    if ('undefined' !== typeof window) {
        return window[getClassName(obj)] === obj;
    }
    if ('undefined' !== typeof global) {
        return global[getClassName(obj)] === obj;
    }
    return false;
}
isGlobalClass.__type = ['obj', 'isGlobalClass', 'P"2!!/"'];
/**
 * Returns true for real objects: object literals ({}) or class instances (new MyClass).
 *
 * @public
 */
function isObject(obj) {
    if (obj === null) {
        return false;
    }
    return (typeof obj === 'object' && !(0, exports.isArray)(obj));
}
isObject.__type = ['obj', 'isObject', 'P"2!!/"'];
/**
 * Returns true if given obj is a plain object, and no Date, Array, Map, Set, etc.
 *
 * This is different to isObject and used in the type system to differentiate
 * between JS objects in general and what we define as ReflectionKind.objectLiteral.
 * Since we have Date, Set, Map, etc. in the type system, we need to differentiate
 * between them and all other object literals.
 */
function isObjectLiteral(obj) {
    return isObject(obj) && !(obj instanceof Date) && !(obj instanceof Map) && !(obj instanceof Set);
}
isObjectLiteral.__type = ['obj', 'isObjectLiteral', 'P"2!!/"'];
/**
 * @public
 */
exports.isArray = Array.isArray;
/**
 * @public
 */
function isNull(obj) {
    return null === obj;
}
isNull.__type = ['obj', 'isNull', 'P"2!!/"'];
/**
 * @public
 */
function isUndefined(obj) {
    return undefined === obj;
}
isUndefined.__type = ['obj', 'isUndefined', 'P"2!!/"'];
/**
 * Checks if obj is not null and not undefined.
 *
 * @public
 */
function isSet(obj) {
    return !isNull(obj) && !isUndefined(obj);
}
isSet.__type = ['obj', 'isSet', 'P"2!)/"'];
/**
 * @public
 */
function isNumber(obj) {
    return 'number' === identifyType(obj);
}
isNumber.__type = ['obj', 'isNumber', 'P"2!!/"'];
/**
 * Returns true if given value is strictly a numeric string value (or a number).
 *
 * ```typescript
 * isNumeric(12); //true
 * isNumeric('12'); //true
 * isNumeric('12.3'); //true
 * isNumeric('12.3 '); //false
 * isNumeric('12px'); //false
 * ```
 * @public
 */
function isNumeric(s) {
    if ('number' === typeof s)
        return true;
    let points = 0;
    for (let i = s.length - 1; i >= 0; i--) {
        const d = s.charCodeAt(i);
        if (d === 46) {
            //46 = .
            if (points++ > 0)
                return false;
            continue;
        }
        if (d < 48 || d > 57)
            return false;
    }
    return true;
}
isNumeric.__type = ['s', 'isNumeric', 'PP&\'J2!)/"'];
exports.isInteger = Number.isInteger || __assignType(function (obj) {
    return (obj % 1) === 0;
}, ['obj', '', 'P"2!"/"']);
/**
 * @public
 */
function isString(obj) {
    return 'string' === identifyType(obj);
}
isString.__type = ['obj', 'isString', 'P"2!!/"'];
/**
 * @public
 */
function indexOf(array, item) {
    if (!array) {
        return -1;
    }
    return array.indexOf(item);
}
indexOf.__type = ['array', 'item', 'indexOf', 'P"F2!"2"\'/#'];
/**
 * @public
 */
async function sleep(seconds) {
    return (Promise.Ω = [['$']], new Promise(__assignType(resolve => setTimeout(resolve, seconds * 1000), ['resolve', '', 'P"2!"/"'])));
}
sleep.__type = ['seconds', 'sleep', 'P\'2!$`/"'];
/**
 * Creates a shallow copy of given array.
 *
 * @public
 */
function copy(v) {
    if ((0, exports.isArray)(v)) {
        return v.slice(0);
    }
    return v;
}
copy.__type = ['v', 'copy', 'P"F2!"F/"'];
/**
 * Checks whether given array or object is empty (no keys). If given object is falsy, returns false.
 *
 * @public
 */
function empty(value) {
    if (!value)
        return true;
    if ((0, exports.isArray)(value)) {
        return value.length === 0;
    }
    else {
        for (const i in value)
            if (value.hasOwnProperty(i))
                return false;
        return true;
    }
}
empty.__type = ['value', 'empty', 'PP"F%PMJ2!8)/"'];
/**
 * Returns the size of given array or object.
 *
 * @public
 */
function size(array) {
    if (!array) {
        return 0;
    }
    if ((0, exports.isArray)(array)) {
        return array.length;
    }
    else {
        return getObjectKeysSize(array);
    }
}
size.__type = ['array', 'size', 'PP"FP&"LMJ2!\'/"'];
/**
 * Returns the first key of a given object.
 *
 * @public
 */
function firstKey(v) {
    return Object.keys(v)[0];
}
firstKey.__type = ['v', 'firstKey', 'PPP&"LM%J2!P&-J/"'];
/**
 * Returns the last key of a given object.
 *
 * @public
 */
function lastKey(v) {
    const keys = Object.keys(v);
    if (keys.length) {
        return;
    }
    return keys[keys.length - 1];
}
lastKey.__type = ['v', 'lastKey', 'PPP&"LM%J2!P&-J/"'];
/**
 * Returns the first value of given array or object.
 *
 * @public
 */
function first(v) {
    if ((0, exports.isArray)(v)) {
        return v[0];
    }
    const key = firstKey(v);
    if (key) {
        return v[key];
    }
    return;
}
first.__type = ['v', 'first', 'PPP&"LM"FJ2!P"-J/"'];
/**
 * Returns the last value of given array or object.
 *
 * @public
 */
function last(v) {
    if ((0, exports.isArray)(v)) {
        if (v.length > 0) {
            return v[v.length - 1];
        }
        return;
    }
    const key = firstKey(v);
    if (key) {
        return v[key];
    }
    return;
}
last.__type = ['v', 'last', 'PPP&"LM"FJ2!P"-J/"'];
/**
 * Returns the average of a number array.
 *
 * @public
 */
function average(array) {
    let sum = 0;
    for (const n of array) {
        sum += n;
    }
    return sum / array.length;
}
average.__type = ['array', 'average', 'P\'F2!\'/"'];
/**
 * @public
 */
function prependObjectKeys(o, prependText) {
    const converted = {};
    for (const i in o) {
        if (!o.hasOwnProperty(i))
            continue;
        converted[prependText + i] = o[i];
    }
    return converted;
}
prependObjectKeys.__type = ['o', 'prependText', 'prependObjectKeys', 'PP&"LM2!&2"P&"LM/#'];
/**
 * @public
 */
function appendObject(origin, extend, prependKeyName = '') {
    const no = prependObjectKeys(extend, prependKeyName);
    for (const [i, v] of (0, iterators_js_1.eachPair)(no)) {
        origin[i] = v;
    }
}
appendObject.__type = ['origin', 'extend', 'prependKeyName', () => "", 'appendObject', 'PP&"LM2!P&"LM2"&2#>$"/%'];
/**
 * A better alternative to "new Promise()" that supports error handling and maintains the stack trace for Error.stack.
 *
 * When you use `new Promise()` you need to wrap your code inside a try-catch to call `reject` on error.
 * asyncOperation() does this automatically.
 *
 * When you use `new Promise()` you will lose the stack trace when `reject(new Error())` is called.
 * asyncOperation() makes sure the error stack trace is the correct one.
 *
 * @example
 * ```typescript
 * await asyncOperation(async (resolve, reject) => {
 *     await doSomething(); //if this fails, reject() will automatically be called
 *     stream.on('data', (data) => {
 *         resolve(data); //at some point you MUST call resolve(data)
 *     });
 * });
 * ```
 *
 * @public
 * @reflection never
 */
async function asyncOperation(executor) {
    try {
        return await (Promise.Ω = [undefined], new Promise(async (resolve, reject) => {
            try {
                await executor(resolve, reject);
            }
            catch (e) {
                reject(e);
            }
        }));
    }
    catch (error) {
        mergeStack(error, createStack());
        throw error;
    }
}
/**
 * When an API is called that returns a promise that loses the stack trace on error, you can use fixAsyncOperation().
 *
 * ```typescript
 * cons storage = new BrokenPromiseStorage();
 * const files = await fixAsyncOperation(storage.files('/'));
 * ```
 */
function fixAsyncOperation(promise) {
    return asyncOperation(__assignType(async (resolve, reject) => {
        resolve(await promise);
    }, ['resolve', 'reject', '', 'P"2!"2""/#']));
}
fixAsyncOperation.__type = ['promise', 'fixAsyncOperation', 'P"`2!"`/"'];
/**
 * @public
 */
function mergePromiseStack(promise, stack) {
    stack = stack || createStack();
    promise.then(() => {
    }, __assignType((error) => {
        mergeStack(error, stack || '');
    }, ['error', '', 'P"2!"/"']));
    return promise;
}
mergePromiseStack.__type = ['promise', 'stack', 'mergePromiseStack', 'P"`2!&2"8"`/#'];
/**
 * @beta
 */
function createStack(removeCallee = true) {
    if (Error.stackTraceLimit === 10)
        Error.stackTraceLimit = 100;
    let stack = new Error().stack || '';
    /*
    at createStack (/file/path)
    at promiseToObservable (/file/path)
    at userLandCode1 (/file/path)
    at userLandCode2 (/file/path)
     */
    //remove "at createStack"
    stack = stack.slice(stack.indexOf('   at ') + 6);
    stack = stack.slice(stack.indexOf('   at ') - 1);
    if (removeCallee) {
        //remove callee
        stack = stack.slice(stack.indexOf('   at ') + 6);
        stack = stack.slice(stack.indexOf('   at ') - 1);
    }
    return stack;
}
createStack.__type = ['removeCallee', () => true, 'createStack', 'P)2!>"&/#'];
/**
 * @beta
 */
function mergeStack(error, stack) {
    if (error instanceof Error && error.stack) {
        error.stack += '\n' + stack;
    }
}
mergeStack.__type = [() => __ΩError, 'error', 'stack', 'mergeStack', 'Pn!2"&2#"/$'];
/**
 * Makes sure the given value is an error. If it's not an error, it creates a new error with the given value as message.
 */
function ensureError(error, classType = Error) {
    return error instanceof Error || error instanceof AggregateError ? error : new classType(error);
}
ensureError.__type = ['error', () => __ΩClassType, 'classType', () => Error, () => __ΩError, 'ensureError', 'P"2!8n"2#>$n%/&'];
function collectForMicrotask(callback) {
    let items = [];
    let taskScheduled = false;
    return __assignType((arg) => {
        items.push(arg);
        if (!taskScheduled) {
            taskScheduled = true;
            queueMicrotask(() => {
                taskScheduled = false;
                callback(items);
                items.length = 0;
            });
        }
    }, [() => callback, 'args', '', 'arg', 'PPdi!Ph"!F2"$/#qe!!!j2$"/#']);
}
collectForMicrotask.__type = ['args', '', 'callback', 'arg', 'collectForMicrotask', 'PP"F2!$/"2#P"2$$/"/%'];
/**
 * Returns the current time as seconds.
 *
 * @public
 */
function time() {
    return Date.now() / 1000;
}
time.__type = ['time', 'P\'/!'];
/**
 * @public
 */
function getPathValue(bag, parameterPath, defaultValue) {
    if (parameterPath === '' || parameterPath === undefined)
        return bag;
    if (isSet(bag[parameterPath])) {
        return bag[parameterPath];
    }
    const result = dot_prop_1.default.get(bag, parameterPath);
    return isSet(result) ? result : defaultValue;
}
getPathValue.__type = ['bag', 'parameterPath', 'defaultValue', 'getPathValue', 'PP&"LM2!&2""2#8"/$'];
/**
 * @public
 */
function setPathValue(bag, parameterPath, value) {
    dot_prop_1.default.set(bag, parameterPath, value);
}
setPathValue.__type = ['bag', 'parameterPath', 'value', 'setPathValue', 'P%2!&2""2#"/$'];
/**
 * @public
 */
function deletePathValue(bag, parameterPath) {
    dot_prop_1.default.delete(bag, parameterPath);
}
deletePathValue.__type = ['bag', 'parameterPath', 'deletePathValue', 'P%2!&2""/#'];
/**
 * Returns the human-readable byte representation.
 *
 * @public
 */
function humanBytes(bytes, si = false) {
    const thresh = si ? 1000 : 1024;
    if (Math.abs(bytes) < thresh) {
        return bytes + ' B';
    }
    const units = si
        ? ['kB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB']
        : ['KiB', 'MiB', 'GiB', 'TiB', 'PiB', 'EiB', 'ZiB', 'YiB'];
    let u = -1;
    do {
        bytes /= thresh;
        ++u;
    } while (Math.abs(bytes) >= thresh && u < units.length - 1);
    return bytes.toFixed(2) + ' ' + units[u];
}
humanBytes.__type = ['bytes', 'si', () => false, 'humanBytes', 'P\'2!)2">#&/$'];
/**
 * Returns the number of properties on `obj`. This is 20x faster than Object.keys(obj).length.
 */
function getObjectKeysSize(obj) {
    let size = 0;
    for (let i in obj)
        if (obj.hasOwnProperty(i))
            size++;
    return size;
}
getObjectKeysSize.__type = ['obj', 'getObjectKeysSize', 'P%2!\'/"'];
function isConstructable(fn) {
    try {
        new new Proxy(fn, { construct: () => ({}) });
        return true;
    }
    catch (err) {
        return false;
    }
}
isConstructable.__type = ['fn', 'isConstructable', 'P"2!)/"'];
function isPrototypeOfBase(prototype, base) {
    if (!prototype)
        return false;
    if (prototype === base)
        return true;
    let currentProto = Object.getPrototypeOf(prototype);
    while (currentProto && currentProto !== Object.prototype) {
        if (currentProto === base)
            return true;
        currentProto = Object.getPrototypeOf(currentProto);
    }
    return false;
}
isPrototypeOfBase.__type = [() => __ΩAbstractClassType, 'prototype', () => __ΩClassType, 'base', 'isPrototypeOfBase', 'PPn!-J2"n#2$)/%'];
function getParentClass(classType) {
    const parent = Object.getPrototypeOf(classType);
    if (parent === Object.prototype || Object.getPrototypeOf(parent) === Object.prototype)
        return;
    return parent;
}
getParentClass.__type = [() => __ΩClassType, 'classType', () => __ΩClassType, 'getParentClass', 'Pn!2"Pn#-J/$'];
function getInheritanceChain(classType) {
    const chain = [classType];
    let current = classType;
    while (current = getParentClass(current)) {
        chain.push(current);
    }
    return chain;
}
getInheritanceChain.__type = [() => __ΩClassType, 'classType', () => __ΩClassType, 'getInheritanceChain', 'Pn!2"n#F/$'];
function inDebugMode() {
    return typeof v8debug === 'object' ||
        (typeof process !== 'undefined' && /--debug|--inspect/.test(process.execArgv.join(' ')));
}
inDebugMode.__type = ['inDebugMode', 'P"/!'];
/**
 * Create a new class with the given name.
 * This is currently the only know way to make it workable in browsers too.
 */
function createDynamicClass(name, base) {
    if (base) {
        let baseName = getClassName(base);
        if (baseName === name)
            baseName += 'Base';
        return new Function(baseName, `return class ${name} extends ${baseName} {}`)(base);
    }
    return new Function(`return class ${name} {}`)();
}
createDynamicClass.__type = ['name', () => __ΩClassType, 'base', () => __ΩClassType, 'createDynamicClass', 'P&2!n"2#8n$/%'];
function isIterable(value) {
    return (0, exports.isArray)(value) || value instanceof Set || value instanceof Map;
}
isIterable.__type = ['value', 'isIterable', 'P"2!)/"'];
function iterableSize(value) {
    return (0, exports.isArray)(value) ? value.length : value.size || 0;
}
iterableSize.__type = ['value', 'iterableSize', 'PP#F#D##EJ2!\'/"'];
/**
 * Returns __filename, works in both cjs and esm.
 */
function getCurrentFileName() {
    const e = new Error;
    const initiator = e.stack.split('\n').slice(2, 3)[0];
    let path = /(?<path>[^(\s]+):[0-9]+:[0-9]+/.exec(initiator).groups.path;
    if (path.indexOf('file') >= 0) {
        path = new URL(path).pathname;
    }
    if (path[0] === '/' && process.platform === 'win32') {
        path = path.slice(1);
    }
    return path;
}
getCurrentFileName.__type = ['getCurrentFileName', 'P&/!'];
/**
 * Escape special characters in a regex string, so it can be used as a literal string.
 */
function escapeRegExp(string) {
    return string.replace(/[.*+?^${}()|[\]\\]/g, '\\$&'); // $& means the whole matched string
}
escapeRegExp.__type = ['string', 'escapeRegExp', 'P&2!&/"'];
function hasProperty(object, property) {
    return Object.prototype.hasOwnProperty.call(object, property);
}
hasProperty.__type = ['object', 'property', 'hasProperty', 'P"2!"2")/#'];
/**
 * Returns an iterator of numbers from start (inclusive) to stop (exclusive) by step.
 */
function* range(startOrLength, stop = 0, step = 1) {
    let i = startOrLength;
    let end = stop;
    if (stop === 0) {
        i = 0;
        end = startOrLength;
    }
    for (; i < end; i += step) {
        yield i;
    }
}
range.__type = ['startOrLength', 'stop', () => 0, 'step', () => 1, () => __ΩIterableIterator, 'range', 'P\'2!\'2">#\'2$>%\'o&"/\''];
/**
 * Returns an array of numbers from start (inclusive) to stop (exclusive) by step.
 *
 * Works the same as python's range function.
 */
function rangeArray(startOrLength, stop = 0, step = 1) {
    return [...range(startOrLength, stop, step)];
}
rangeArray.__type = ['startOrLength', 'stop', () => 0, 'step', () => 1, 'rangeArray', 'P\'2!\'2">#\'2$>%\'F/&'];
/**
 * Returns a combined array of the given arrays.
 *
 * Works the same as python's zip function.
 */
function zip(...args) {
    const minLength = Math.min(...args.map(__assignType((arr) => arr.length, ['arr', '', 'P"2!"/"'])));
    //@ts-ignore
    return Array.from({ length: minLength }).map(__assignType((_, i) => args.map(__assignType((arr) => arr[i], ['arr', '', 'P"2!"/"'])), ['_', 'i', '', 'P"2!"2""/#']));
}
zip.__type = ['args', 'zip', 'l:e"!R!RPd"e#!fh!!Fqk#\'QRP"@2!Pd"gN)!F/"'];
/**
 * Forwards the runtime type arguments from function x to function y.
 * This is necessary when a generic function is overridden and forwarded to something else.
 *
 * ```typescript
 * let generic = <T>(type?: ReceiveType<T>) => undefined;
 *
 * let forwarded<T> = () => {
 *     forwardTypeArguments(forwarded, generic); //all type arguments are forwarded to generic()
 *     generic(); //call as usual
 * }
 *
 * forwarded<any>(); //generic receives any in runtime.
 * ```
 *
 * Note that generic.bind(this) will not work, as bind() creates a new function and forwarded type arguments can not
 * reach the original function anymore.
 *
 * ```typescript
 * let forwarded<T> = () => {
 *     const bound = generic.bind(this);
 *     forwardTypeArguments(forwarded, bound); //can not be forwarded anymore
 *     bound(); //fails
 * }
 * ```
 *
 *  This is a limitation of JavaScript. In this case you have to manually forward type arguments.
 *
 *  ```typescript
 *  let forwarded<T> = (type?: ReceiveType<T>) => {
 *     const bound = generic.bind(this);
 *     bound(type);
 *  }
 *  ```
 */
function forwardTypeArguments(x, y) {
    y.Ω = x.Ω;
    x.Ω = undefined;
}
forwardTypeArguments.__type = ['x', 'y', 'forwardTypeArguments', 'P"2!"2"$/#'];
function formatError(error, withStack = false) {
    if (error && error.name === 'AggregateError' && 'errors' in error) {
        return `${(withStack && error.stack) || `AggregateError: ${error.message}`}\nErrors:\n${error.errors.map(__assignType((v) => formatError(v), ['v', '', 'P"2!"/"'])).join('\n')}`;
    }
    if (error instanceof Error) {
        let current = error.cause;
        let errors = [(withStack && error.stack) || error.message || 'Error'];
        while (current) {
            errors.push(`cause by ${formatError(current)}`);
            current = current.cause;
        }
        return errors.join('\n');
    }
    if (withStack && error.stack)
        return error.stack;
    return String(error);
}
formatError.__type = ['error', 'withStack', () => false, 'formatError', 'P"2!)2">#&/$'];
/**
 * Asserts that the given object is an instance of the given class.
 */
function assertInstanceOf(object, constructor) {
    if (!(object instanceof constructor)) {
        throw new Error(`Object ${getClassName(object)} is not an instance of the expected class ${getClassName(constructor)}`);
    }
}
assertInstanceOf.__type = ['object', 'args', 'new', 'constructor', 'assertInstanceOf', 'P"2!PP"@2""1#M2$!/%'];
/**
 * Asserts that the given value is defined (not null and not undefined).
 */
function assertDefined(value) {
    if (value === null || value === undefined) {
        throw new Error(`Value is not defined`);
    }
}
assertDefined.__type = ['value', 'assertDefined', 'P"2!!/"'];
//# sourceMappingURL=core.js.map