type AsyncSubscriber<T> = (event: T) => Promise<void> | void;
type Subscriber<T> = (event: T) => Promise<void> | void;
export type AsyncEventSubscription = {
    unsubscribe: () => void;
};
export type EventSubscription = {
    unsubscribe: () => void;
};
export declare class EmitterEvent {
    readonly id: number;
    stopped: boolean;
    propagationStopped: boolean;
    /**
     * Stop propagating the event to subsequent event listeners.
     */
    stopPropagation(): void;
    /**
     * Signal the emitter that you want to abort.
     * Subsequent event listeners will still be called.
     */
    stop(): void;
}
export declare class EventEmitter<T extends EmitterEvent> {
    protected parent?: EventEmitter<any> | undefined;
    protected subscribers: Subscriber<T>[];
    constructor(parent?: EventEmitter<any> | undefined);
    subscribe(callback: Subscriber<T>): EventSubscription;
    emit(event: T): void;
    hasSubscriptions(): boolean;
}
export declare class AsyncEventEmitter<T extends EmitterEvent> {
    protected parent?: AsyncEventEmitter<any> | undefined;
    protected subscribers: AsyncSubscriber<T>[];
    constructor(parent?: AsyncEventEmitter<any> | undefined);
    subscribe(callback: AsyncSubscriber<T>): AsyncEventSubscription;
    emit(event: T): Promise<void>;
    hasSubscriptions(): boolean;
}
export {};
export declare type __ΩAsyncEventSubscription = any[];
export declare type __ΩEventSubscription = any[];
